import { getProjectRoot, getConfig, FileRouter } from '@midwayjs/hooks-core';

async function MidwayHooksLoader(source) {
  const callback = this.async();
  const root = getProjectRoot();
  const projectConfig = getConfig();
  const router = new FileRouter({
    root,
    projectConfig,
    useSourceFile: true
  });

  if (!router.isApiFile(this.resourcePath)) {
    return callback(null, source);
  }

  const route = router.getRoute(this.resourcePath);
  const Gateway = router.getGatewayByRoute(route);
  const client = await Gateway.createApiClient(this.resourcePath, source, new Gateway.router({
    root,
    projectConfig,
    useSourceFile: true
  }));
  callback(null, client);
}

export default MidwayHooksLoader;
